# The ipv6calc Homepage

## General

ipv6calc is a small utility written in programming language C to manipulate (not only) IPv6 addresses and is able to do other tricky things. Intentions were convering a given IPv6 address into compressed format, convering a given IPv6 address into the same format like shown in /proc/net/if_inet6 and (because it was not difficulty) migrating the Perl program ip6_int into. Now only one utiltity is needed to do a lot.

This utility was also used in the past to extend features on network-functions-ipv6 library, used by initscripts-ipv6.

Note: this tool got also its freecode.com (former freshmeat, now also EOL) / ipv6calc page (but this is not maintained by the author)

### Latest version

Latest version since last update of this page is 1.0.0

### Included programs

- “ipv6calc”: the main utility

- “ipv6calcweb”: CGI wrapper for ipv6calc's address information output

- “ipv6logconv”: log converter (IPv4/IPv6)

- “ipv6loganon”: log anonymizer (IPv4/IPv6)

- “ipv6logstats”: log statistic generator (IPv4/IPv6)

- “mod_ipv6calc”: Apache module

### Included databases

If not disabled during compiling of the tool, following databases are statically included, since version 0.95.0 internally mentioned as “BuiltIn”:

- IEEE IAB, OUI, OUI-36 databases (for decoding vendor part of MAC/EUI-48/EUI-64)

- IPv4 assignment databases from IANA, ARIN, RIPENCC, APNIC, LACNIC, AFRINIC (for selecting proper registry in ipv6calcweb.cgi and IPv4 anonymization)

- IPv6 assignment databases from IANA, ARIN, RIPENCC, APNIC, LACNIC, AFRINIC (for selecting proper registry in ipv6calcweb.cgi and IPv6 anonymization)

- ASN assignment databases from IANA, ARIN, RIPENCC, APNIC, LACNIC, AFRINIC (for IPv4/IPv6 anonymization)

- LISP assignment database for supplying extra info

### Possible external databases

If enabled during compiling the tool, following external (but local stored) databases can be used

- GeoIP

  - IPv4 (since 0.61.0, released 2006)

  - IPv6 (since 0.90.0, released 2011, req. GeoIP >= 1.4.5)

  - release 0.99.0 is tested against GeoIP >= 1.4.4

- IP2Location

  - IPv4 (since 0.60.0, released 2006)

  - IPv6 (since 0.70.0, released 2007, IP2Location LITE IPv6 Databases since 0.99.0, released 2015)

  - release 0.99.0 is tested against IP2Location >= 4.0.2

- DB-IP.com (since 0.98.0, released 2015), based on local Berkeley DB files generated from downloaded CSV files

- “External” (since 0.98.0, released 2015), based on local Berkeley DB files, generated from downloaded TXT/XML files (registries assignment databases). Supporting IPv4/IPv6 to Registries and IPv4/IPv6 to CountryCode. If newer, overruling the related included databases.

Since version 0.95.0 the tool can be compiled to use dynamically loading of library, means the binaries can be also used on systems where IP2Location or GeoIP libraries are not existing. On such system, the support is simply disabled then and some capabilities/features which requires the databases are disabled.

Since version 0.97.4 also fallback code for GeoIP and IP2Location is included in the source package, means that support of dynamically loading of library can be included during compilation without having related development sources on the system.

## License

The program is published under the GNU GPL version 2.

## Copyright

(C) 2001 - 2017 by Dr. Peter Bieringer

## Author

The author of ipv6calc is

- Dr. Peter Bieringer with some minor contribution by others

## Where to get sources or binaries

### Latest version of sources

- Via GitHub (since 2016-09-05) at GitHub / ipv6calc

### Releases

#### as tar.gz or zip

- via HTTPS at GitHub / ipv6calc / releases

#### as tar.gz (signed)

- Via FTP at DeepSpace6: DeepSpace6 / anonymous FTP

- Via FTP at ftp://ftp.bieringer.de/pub/linux/IPv6/ipv6calc/

Since version 0.95.0 packages are signed with new GPG key, also available here: CODE-GPG-KEY-bieringer.de-2013 @ftp.bieringer.de or CODE-GPG-KEY-bieringer.de-2013 @ftp.deepspace6.net

    Key fingerprint: AAB3 8CB7 97C7 50C7 78C6 08C6 DDEB 141D F738 0F61
    uid: Peter Bieringer (Code Signing Key 2013) <code@bieringer.de>

A SPEC file is included, so you can build a RPM from tar.gz using

    $ rpmbuild -ta path/to/ipv6calc-$version.tar.gz

In addition, conditional build options are available (see related configure options below):

    --without geoip
    --without ip2location
    --without dbip
    --without external
    --without shared
    --without mod_ipv6calc

#### as RPM

Currently only on rpmfind / ipv6calc, but there are plans to publish at least source RPMS on DeepSpace6 some day.

### Ready to use packages for several operating systems:

#### Fedora Linux

Fedora 22 is the current developing platform, so use given hints above to create a RPM. Since Fedora 7 this package is included by default.

See also FedoraProject / Package / ipv6calc

#### Red Hat Enterprise Linux and clones

It's tested by the developer that creation of the RPM is working fine starting with RHEL 4.

- RHEL/CentOS 5 has the package included by default (but an rather old version)

  - RPMs of newer releases are available as test builds on koji, see related URL in announcements ipv6calc-announce / list archive

- RHEL/CentOS 6/7: available since September 2014 on FedoraProject / EPEL, see also FedoraProject / Package / ipv6calc

CentOS 6/7 are also platforms for regression tests.

#### Gentoo/Funtoo

Package is maintained, nevertheless, Funtoo is used as platform for regression tests.

#### Ubuntu

Package is maintained, more information can be found at https://packages.ubuntu.com/ipv6calc

#### Debian GNU/Linux

Package is maintained, more information can be found at http://packages.debian.org/ipv6calc

#### openSUSE

Package is maintained, more information can be found at http://download.opensuse.org/repositories/home:/uebelhacker/

#### NetBSD

See here for more: ftp://ftp.netbsd.org/pub/pkgsrc/current/pkgsrc/net/ipv6calc/README.html

#### FreeBSD

See here for more: http://www.freshports.org/net-mgmt/ipv6calc/ (http://www.freebsd.org/cgi/query-pr.cgi?pr=34441)

#### OpenBSD

See here for more: http://www.openbsd.org/cgi-bin/cvsweb/ports/net/ipv6calc/

## Configuring & Compiling

### Configuring

Following “ipc6calc” related configure options are currently supported (note: disabling the internal databases reduces the size of the resulting binaries/shared library a lot):

    --disable-dynamic-load  Disable dynamic load of libraries (default: enabled)

    --disable-db-ieee       Disable build-in IEEE database (default: enabled)
    --disable-db-ipv4       Disable build-in IPv4 database (default: enabled)
    --disable-db-ipv6       Disable build-in IPv6 database (default: enabled)
    --disable-db-as-registry Disable built-in AS-to-Registry database (default: enabled)
    --disable-db-cc-registry Disable built-in CountryCode-to-Registry database (default: enabled)

    --enable-dbip           Enable db-ip.com support (default: disabled)
    --enable-external       Enable external db support (default: disabled)
    --enable-ip2location    Enable IP2Location support (default: disabled)
    --enable-geoip          Enable GeoIP support (default: disabled)
    --enable-mod_ipv6calc   Enable build of mod_ipv6calc for Apache (default: disabled)

    --with-ip2location-headers=DIR      IP2Location include files location
    --with-ip2location-headers-fallback IP2Location include files from internal fallback location
                                         (only usable with dynamic load option)
    --with-ip2location-lib=FILE         IP2Location library location
    --with-ip2location-static           Explicitly link IP2Location statically (default=no)
    --with-ip2location-dynamic          Enable use of dynamic loading of IP2Location library (default=no)
    --with-ip2location-db=DIR           Use specified IP2Location database directory, default: /usr/share/IP2Location
    --with-ip2location-dyn-lib=NAME     Use specified IP2Location dynamic library, default: libIP2Location.so

    --with-geoip-headers=DIR        GeoIP include files location
    --with-geoip-headers-fallback   GeoIP include files from internal fallback location
                                     (only usable with dynamic load option)
    --with-geoip-lib=DIR            GeoIP library location
    --with-geoip-static             Explicitly link GeoIP statically (default=no)
    --with-geoip-dynamic            Enable use of dynamic loading of GeoIP library (default=no)
    --with-geoip-db=DIR             Use specified GeoIP database directory, default: /usr/share/GeoIP
    --with-geoip-dyn-lib=NAME       Use specified GeoIP dynamic library, default: libGeoIP.so.1
    --with-geoip-ipv6-compat        Use IPv6 interface of GeoIP in compatibility mode (supporting 1.4.5)

    --with-dbip-db=DIR      Use specified db-ip.com database directory, default:
                              /usr/share/DBIP

    --with-external-db=DIR  Use specified external database directory, default:
                              /usr/share/ipv6calc/db

    --with-apxs=NAME        name of the apxs executable (apxs)

    --enable-shared                 Enable shared library build (default: disabled)

    --enable-bundled-getopt         Enable bundled getopt library (default: autoselected)
    --enable-bundled-md5            Enable bundled MD5 library (default: autoselected)

### Compiling

As usual, use

    $ make

and run tests afterwards using

    $ make test

or at least (e.g. if external databases are not available)

    $ make test-minimal

### Configuring & Compiling with Presets

A shell script is included which can configure and compile with standard presets (also used during regression tests):

    $ ./autogen.sh -h
    Supported options:
       -?|-h|--help        : this help
       -n|--no-make        : stop before running 'make'
       -a|--all            : enable GeoIP/IP2Location/db-ip.com/External/mod_ipv6calc support
       -g|--geoip          : enable GeoIP support
       --geoip-dyn|-G      : switch to dynamic library loading of GeoIP
       -i|--ip2location    : enable IP2Location support
       --ip2location-dyn|-I: switch to dynamic library loading of IP2Location
       -d|--dbip           : enable db-ip.com support
       -e|--external       : enable external database support
       --disable-db-ieee   : disable built-in IEEE database
       --disable-db-ipv4   : disable built-in IPv4 database
       --disable-db-ipv6   : disable built-in IPv6 database
       --geoip-ipv6-compat : enable GeoIP IPv6 compatibility mode
       -S                  : enable shared library mode
       -no-static-build    : skip static build
       --no-test           : skip 'make test'

## Mailling Lists

### ipv6calc-announce

Reason:

- sending announcements of new versions

Traffic:

- very low

Postings:

- only moderators are allowed to post

Information:

- DeepSpace6 / maillist ipv6calc-announce

### ipv6calc

Reason:

- discussions

Traffic:

- low

Postings:

- subscribers

Information:

- DeepSpace6 / maillist ipv6calc

## Bug Reports

You can send bug reports to the author himself or subscribe to maillist “ipv6calc” and send it to the list.

## Features of ipv6calc

### Description

The main program named “ipv6calc” is able to recognize many (not only) IPv6 address formats and depending on a selectable action (not required) a selectable output format can be specified. Also it has the capability to show detailed information of an IPv4/IPv6 address or anonymize it.

### List of built-in features

Option “-v” shows built-in features, depending on configuration before compiling:

    $ ipv6calc -v
    ipv6calc: version 0.99.3 GeoIP GeoIPv6 IP2Location IP2Location6 DBIPv4 DBIPv6 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_IPV4_COUNTRY DB_IPV6_COUNTRY DB_IPV4_CITY DB_IPV6_CITY DB_IPV4_REGION DB_IPV6_REGION DB_CC_REG DB_IEEE DB_IPV4_INFO DB_IPV6_INFO ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC

Option “-v -v” (since 0.91.0) shows built-in features and capabilities in detail, depending on configuration before compiling:

    $ ipv6calc -vv
    ipv6calc: version 0.99.3.rc1 GeoIP GeoIPv6 IP2Location IP2Location6 DBIPv4 DBIPv6 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_IPV4_COUNTRY DB_IPV6_COUNTRY DB_IPV4_CITY DB_IPV6_CITY DB_IPV4_REGION DB_IPV6_REGION DB_CC_REG DB_IEEE DB_IPV4_INFO DB_IPV6_INFO ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC
    Capabilities: GeoIP(linked) IP2Location(linked) DBIP External DB_AS_REG(BuiltIn) DB_CC_REG(BuiltIn) DB_IPV4_REG(BuiltIn) DB_IPV6_REG(BuiltIn) DB_IEEE(BuiltIn)
    Internal main     library version: 0.99.3  API: 0.99.3  (built-in)
    Internal database library version: 0.99.3  API: 0.99.3  (built-in)
    Compiled: Feb 26 2017  11:04:37
    GeoIP support enabled, compiled with IPv4 & IPv6 support
    GeoIP dynamic library version (on this system): 1.6.9
    GeoIP available databases: Country4=1 Country6=1 ASN4=1 ASN6=1 City4=1 City6=1
    IP2Location support enabled, compiled with API version: 8.0.4, dynamically linked with version: 8.0.4 API=8.0.4 Major=8
    IP2Location available databases: Country4=1 Country6=1 ASN4=0 ASN6=0 City4=1 City6=1
    BuiltIn databases available: ASN_REG=1 IPV4_REG=1 IPV6_REG=1 IEEE=1 CC_REG=1
    DB features: 0xff01ffff
    GeoIP: features available/implemented: 0x03003ff0/0x03003ff0 (100%)
    GeoIP: info of available databases in directory: /usr/share/GeoIP (max: 31)
    GeoIP: GeoIP Country Edition            :[ 1] GeoIP.dat            (GEO-106FREE 20161004 Build 1 Copy)
    GeoIP: GeoIP City Edition, Rev 1        :[ 2] GeoIPCity.dat        (GEO-533LITE 20161004 Build 1 Copyright (c) 2016 MaxMind Inc All Rights Re)
    GeoIP: GeoIP ASNum Edition              :[ 9] GeoIPASNum.dat       (GEO-117 20161002 Build 1 Copyright (c) 2016 MaxMind Inc All Rights Re)
    GeoIP: GeoIP Country V6 Edition         :[12] GeoIPv6.dat          (GEO-106FREE 20161004 Build 1 C)
    GeoIP: GeoIP ASNum V6 Edition           :[21] GeoIPASNumv6.dat     (GEO-117 20160911 Build 1 Copyright (c) 2016 MaxMind Inc All Rights)
    GeoIP: GeoIP City Edition V6, Rev 1     :[30] GeoIPCityv6.dat      (GEO-536LITE 20161004 Build 1 Copyright (c) 2016 MaxMind Inc All Rights Reser)
    IP2Location: features available/implemented: 0x0c003fc0/0x0c003fc0 (100%)
    IP2Location: info of available databases in directory: /usr/share/IP2Location
    IP2Location: Copyright (c) IP2Location All Rights Reserved
    IP2Location: IPv4 Co/Re/Ci/LaLo/ZI/TZ/IS/Do/Ne/Ar/We/Mo      :[ 68] IP-COUNTRY-REGION-CITY-LATITUDE-LONGITUDE-ZIPCODE-TIMEZONE-ISP-DOMAIN-NETSPEED-AREACODE-WEATHER-MOBILE-SAMPLE.BIN (IP2L-DB20 IPv4 SAMPLE 20160604)
    IP2Location: IPv4 Co/Re/Ci/LaLo/ZI/TZ/IS/Do/Ne/Ar/We/Mo/El/Us:[ 72] IP-COUNTRY-REGION-CITY-LATITUDE-LONGITUDE-ZIPCODE-TIMEZONE-ISP-DOMAIN-NETSPEED-AREACODE-WEATHER-MOBILE-ELEVATION-USAGETYPE-SAMPLE.BIN (IP2L-DB24 IPv4 SAMPLE 20160604)
    IP2Location: IPv6 Co/Re/Ci/LaLo/ZI/TZ/IS/Do/Ne/Ar/We/Mo      :[ 92] IPV6-COUNTRY-REGION-CITY-LATITUDE-LONGITUDE-ZIPCODE-TIMEZONE-ISP-DOMAIN-NETSPEED-AREACODE-WEATHER-MOBILE.SAMPLE.BIN (IP2L-DB20 IPv6 SAMPLE 20160604)
    IP2Location: IPv6 Co/Re/Ci/LaLo/ZI/TZ/IS/Do/Ne/Ar/We/Mo/El/Us:[ 96] IPV6-COUNTRY-REGION-CITY-LATITUDE-LONGITUDE-ZIPCODE-TIMEZONE-ISP-DOMAIN-NETSPEED-AREACODE-WEATHER-MOBILE-ELEVATION-USAGETYPE.SAMPLE.BIN (IP2L-DB24 IPv6 SAMPLE 20160604)
    IP2Location: IPv4 Country                                    :[100] IP2LOCATION-LITE-DB1.BIN            (IP2L-DB1 IPv4 LITE 20150329)
    IP2Location: IPv4 Country/Region/City                        :[102] IP2LOCATION-LITE-DB3.BIN            (IP2L-DB3 IPv4 LITE 20150329)
    IP2Location: IPv4 Country/Region/City/LongitudeLattitude     :[104] IP2LOCATION-LITE-DB5.BIN            (IP2L-DB5 IPv4 LITE 20150329)
    IP2Location: IPv4 Co/Re/Ci/LattLong/ZIP                      :[106] IP2LOCATION-LITE-DB9.BIN            (IP2L-DB9 IPv4 LITE 20150329)
    IP2Location: IPv4 Co/Re/Ci/LattLong/ZIP/TZ                   :[108] IP2LOCATION-LITE-DB11.BIN           (IP2L-DB11 IPv4 LITE 20150329)
    IP2Location: IPvx Country                                    :[101] IP2LOCATION-LITE-DB1.IPV6.BIN       (IP2L-DB1 IPv6 LITE 20150329)
    IP2Location: IPvx Country/ISP                                :[103] IP2LOCATION-LITE-DB3.IPV6.BIN       (IP2L-DB3 IPv6 LITE 20150329)
    IP2Location: IPvx Country/Region/City/LongitudeLattitude     :[105] IP2LOCATION-LITE-DB5.IPV6.BIN       (IP2L-DB5 IPv6 LITE 20150329)
    IP2Location: IPvx Co/Re/Ci/LattLong/ZIP                      :[107] IP2LOCATION-LITE-DB9.IPV6.BIN       (IP2L-DB9 IPv6 LITE 20150329)
    IP2Location: IPvx Co/Re/Ci/LattLong/ZIP/TZ                   :[109] IP2LOCATION-LITE-DB11.IPV6.BIN      (IP2L-DB11 IPv6 LITE 20150329)
    IP2Location: IPvx Country                                    :[ 25] IPV6-COUNTRY.BIN                    (IP2L-DB1 IPv6 20060918)
    IP2Location: IPvx Co/Re/Ci/LattLong/ZIP/TZ                   :[ 35] IPV6-COUNTRY-REGION-CITY-LATITUDE-LONGITUDE-ZIPCODE-TIMEZONE.BIN (IP2L-DB11 IPv6 20160928)
    IP2Location: IPv6 Country                                    :[120] IPV6-COUNTRY-FREE.BIN               (IP2L-DB1 IPv6 FREE 20140723 INCOMPATIBLE)
    IP2Location: detected best databases SAMPLE  Country4=72   Country6=96   City4=72   City6=96
    IP2Location: detected best databases LITE    Country4=109  Country6=109  City4=109  City6=109
    IP2Location: detected best databases COMM    Country4=35   Country6=35   City4=35   City6=35
    IP2Location: selected best databases LI->SA* Country4=72   Country6=96   City4=72   City6=96
    IP2Location: selected best databases normal  Country4=35   Country6=35   City4=35   City6=35
    IP2Location: selected best databases method: * = autoswitch from LITE to SAMPLE enabled in case not older than 12 months and having more features
    IP2Location: selected best databases method: COMM older than 12 months are deselected in case of LITE is available
    IP2Location: selected best databases method: COMM/LITE/SAMPLE with more features are only selected in case not older than 1 months of already found COMM/LITE/SAMPLE
    IP2Location: selected best databases method: softlinks: skipped-by-default
    db-ip.com: features available/implemented: 0x30003fc0/0x30003fc0 (100%)
    DBIP: info of available databases in directory: /usr/share/DBIP
    DBIP: IPv4 CountryCode (FREE)       : ipv6calc-dbip-ipv4-country.db  (DBIP-1/20161001, created: 20161009-090609 UTC)
    DBIP: IPv6 CountryCode (FREE)       : ipv6calc-dbip-ipv6-country.db  (DBIP-2/20161001, created: 20161009-090609 UTC)
    DBIP: IPv4 City/Region/CountryCode (FREE): ipv6calc-dbip-ipv4-city.db     (DBIP-3/20161001, created: 20161009-090650 UTC)
    DBIP: IPv6 City/Region/CountryCode (FREE): ipv6calc-dbip-ipv6-city.db     (DBIP-4/20161001, created: 20161009-090650 UTC)
    DBIP: IPv4 Location/ISP (COMM)      : ipv6calc-dbip-ipv4-full.db     (DBIP-9/20170201, created: 20170221-183104 UTC)
    DBIP: IPv6 Location/ISP (COMM)      : ipv6calc-dbip-ipv6-full.db     (DBIP-10/20170201, created: 20170221-183104 UTC)
    DBIP: detected best databases FREE    Country4=3    Country6=4    City4=3    City6=4
    DBIP: detected best databases COMM    Country4=9    Country6=10   City4=9    City6=10
    DBIP: selected best databases normal  Country4=9    Country6=10   City4=9    City6=10
    DBIP: selected best databases method: COMM older than 12 months are deselected in case of FREE is available
    DBIP: selected best databases method: COMM/FREE with more features are only selected in case not older than 1 months of already found COMM/FREE
    External: features available/implemented: 0xc00000cc/0xc00180cc (75%)
    External: info of available databases in directory: /usr/share/ipv6calc/db
    External: IPv4 Registry       : ipv6calc-external-ipv4-registry.db       (EXTDB-1/AFRINIC/20160930 APNIC/20160930 ARIN/20160930 IANA/20150810 LACNIC/20160929 RIPENCC/20160929, created: 20160930-164535 UTC)
    External: IPv6 Registry       : ipv6calc-external-ipv6-registry.db       (EXTDB-2/AFRINIC/20160930 IANA/20160128, created: 20161001-051950 UTC)
    External: IPv4 CountryCode    : ipv6calc-external-ipv4-countrycode.db    (EXTDB-3/AFRINIC/20160930 APNIC/20160930 ARIN/20160930 IANA/20150810 LACNIC/20160929 RIPENCC/20160929, created: 20160930-164535 UTC)
    External: IPv6 CountryCode    : ipv6calc-external-ipv6-countrycode.db    (EXTDB-4/AFRINIC/20160930 IANA/20160128, created: 20161001-051950 UTC)
    BuiltIn: features available/implemented: 0x0001c00f/0x0001c00f (100%)
    BuiltIn: info of available databases
    BuiltIn: ASN  : IANA/20160908
    BuiltIn: CC   : AFRINIC/20161224 APNIC/20161223 ARIN/20161224 LACNIC/20161223 RIPENCC/20161223
    BuiltIn: IPv4 : AFRINIC/20170223 APNIC/20170222 ARIN/20170222 IANA/20150810 LACNIC/20170222 LISP/20170223 RIPENCC/20170222 (created: 20170224-184411 UTC)
    BuiltIn: IPv6 : AFRINIC/20170223 APNIC/20170222 ARIN/20170222 IANA/20170104 LACNIC/20170222 LISP/20170223 RIPENCC/20170222 (created: 20170225-075038 UTC)
    BuiltIn: IEEE : IAB/20161218 OUI/20161117 OUI36/20161218
    Database selection or priorization ('->': subsequential calls)
    Database priorization default: GeoIP->IP2Location->db-ip.com->External->BuiltIn
    DB_AS_REG (AS-Number to Registry database): BuiltIn
    DB_CC_REG (CountryCode to Registry database): BuiltIn
    DB_IPV4_REG (IPv4 to Registry database): BuiltIn
    DB_IPV6_REG (IPv6 to Registry database): BuiltIn
    DB_IPV4_AS (IPv4 to AS database): GeoIP
    DB_IPV6_AS (IPv6 to AS database): GeoIP
    DB_IPV4_CC (IPv4 to CountryCode database): GeoIP->IP2Location->db-ip.com->External
    DB_IPV6_CC (IPv6 to CountryCode database): GeoIP->IP2Location->db-ip.com->External
    DB_IPV4_COUNTRY (IPv4 to Country database): GeoIP->IP2Location->db-ip.com
    DB_IPV6_COUNTRY (IPv6 to Country database): GeoIP->IP2Location->db-ip.com
    DB_IPV4_CITY (IPv4 to City database): GeoIP->IP2Location->db-ip.com
    DB_IPV6_CITY (IPv6 to City database): GeoIP->IP2Location->db-ip.com
    DB_IPV4_REGION (IPv4 to Region database): GeoIP->IP2Location->db-ip.com
    DB_IPV6_REGION (IPv6 to Region database): GeoIP->IP2Location->db-ip.com
    DB_IEEE (IEEE/OUI/OUI36 Vendor database): BuiltIn
    DB_IPV4_INFO (IPv4 additional information): BuiltIn
    DB_IPV6_INFO (IPv6 additional information): BuiltIn

Option “-v -h” (since 0.97.4) shows explanation of feature tokens

    $ ipv6calc -v -h
    ipv6calc: version 0.99.3 GeoIP GeoIPv6 IP2Location IP2Location6 DBIPv4 DBIPv6 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_IPV4_COUNTRY DB_IPV6_COUNTRY DB_IPV4_CITY DB_IPV6_CITY DB_IPV4_REGION DB_IPV6_REGION DB_CC_REG DB_IEEE DB_IPV4_INFO DB_IPV6_INFOANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC

    Explanation of available(+)/possible(-) feature tokens
    GeoIP                 + GeoIPv4 database (provided by GeoIP)
    GeoIPv6               + GeoIPv6 database (provided by GeoIP)
    IP2Location           + IP2Location IPv4 database (provided by IP2Location)
    IP2Location6          + IP2Location IPv6 database (provided by IP2Location)
    DBIPv4                + db-ip.com IPv4 database (provided by db-ip.com)
    DBIPv6                + db-ip.com IPv6 database (provided by db-ip.com)
    DB_AS_REG             + AS-Number to Registry database (provided by BuiltIn)
    DB_IPV4_REG           + IPv4 to Registry database (provided by External,BuiltIn)
    DB_IPV6_REG           + IPv6 to Registry database (provided by External,BuiltIn)
    DB_IPV4_AS            + IPv4 to AS database (provided by GeoIP)
    DB_IPV6_AS            + IPv6 to AS database (provided by GeoIP)
    DB_IPV4_CC            + IPv4 to CountryCode database (provided by GeoIP,IP2Location,db-ip.com,External)
    DB_IPV6_CC            + IPv6 to CountryCode database (provided by GeoIP,IP2Location,db-ip.com,External)
    DB_IPV4_COUNTRY       + IPv4 to Country database (provided by GeoIP,IP2Location)
    DB_IPV6_COUNTRY       + IPv6 to Country database (provided by GeoIP,IP2Location)
    DB_IPV4_CITY          + IPv4 to City database (provided by GeoIP,IP2Location,db-ip.com)
    DB_IPV6_CITY          + IPv6 to City database (provided by GeoIP,IP2Location,db-ip.com)
    DB_IPV4_REGION        + IPv4 to Region database (provided by GeoIP,IP2Location,db-ip.com)
    DB_IPV6_REGION        + IPv6 to Region database (provided by GeoIP,IP2Location,db-ip.com)
    DB_CC_REG             + CountryCode to Registry database (provided by BuiltIn)
    DB_IEEE               + IEEE/OUI/OUI36 Vendor database (provided by BuiltIn)
    DB_IPV4_INFO          + IPv4 additional information (provided by External,BuiltIn)
    DB_IPV6_INFO          + IPv6 additional information (provided by External,BuiltIn)
    ANON_ZEROISE          + Anonymization method 'zeroize'
    ANON_ANONYMIZE        + Anonymization method 'anonymize'
    ANON_KEEP-TYPE-ASN-CC + Anonymization method 'keep-type-asn-cc'

Note: since version 0.95.0 the internal layer for database usage was abstracted and each database “plugin” is initialized reporting then its supporting features in binary representation. This makes implementation of other external databases easier in the future. There are at least plans to create an overlay to built-in databases by publishing and use some “precompiled” newer databases replacing the need of recompilation for updated built-in databases.

### Examples

#### Conversion

A simple example is the conversion of an IPv6 address to a DNS PTR query string:

    $ ipv6calc --out revnibbles.arpa 2001:db8::1
    No input type specified, try autodetection...found type: ipv6addr
    1.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.0.8.b.d.0.1.0.0.2.ip6.arpa.

Like you see, input format was autodetected. And the given example can be extended because ipv6calc also understands netmask / prefix length values:

    $ ipv6calc -q --out revnibbles.arpa 2001:db8::1/64
    0.0.0.0.0.0.0.0.8.b.d.0.1.0.0.2.ip6.arpa.

Also you've also learnt now that switch '-q' (quiet) suppresses informational messages. You can use this now to start a DNS PTR query using:

    $ dig PTR `./ipv6calc -q --out revnibbles.arpa 2001:db8::1/64`

But ipv6calc can do many more for you! Next example shows you the extraction of the IPv4 address contained in a 6to4 IPv6 address:

    $ ipv6calc -q --action conv6to4 --in ipv6 2002:c0a8:fb61::1 --out ipv4
    192.168.251.97

This also works vice-versa:

    $ ipv6calc -q --action conv6to4 --in ipv4 192.168.251.97 --out ipv6
    2002:c0a8:fb61::

There are many more features already implemented, if you miss one, send a note.

#### Information

Depending on available databases output can vary.

##### Information about a simple IPv6 address:

    $ ipv6calc -q -i 3ffe:ffff::210:a4ff:fe01:2345
    Address type: unicast, 6bone, global-unicast, productive
    Address type has SLA: 0000
    Registry for address: reserved
    Interface identifier: 0210:a4ff:fe01:2345
    EUI-48/MAC address: 00:10:a4:01:23:45
    MAC is a global unique one
    MAC is an unicast one
    OUI is: XIRCOM

##### Information about a Teredo IPv6 address:

    $ ipv6calc -q -i 3ffe:831f:ce49:7601:8000:efff:af4a:86BF
    Address type: unicast, 6bone, global-unicast, teredo
    Country Code: IT
    Registry for address: 6BONE
    IPv4 address: 80.181.121.64 (TEREDO-CLIENT)
    IPv4 address type: unicast, global
    Autonomous System Information for [80.181.121.64]: AS3269 ASN-IBSNAZ
    Country Code for [80.181.121.64]: IT
    ...

##### Information about a LISP address

    $ ipv6calc -q -i 153.16.26.80
    IPv4 address: 153.16.26.80
    IPv4 address type: unicast, global, lisp
    ...
    IPv4 registry: ARIN(LISP#cbc-xtr)
    ...

##### Machine readable output

There exists also a machine readable output (e.g. used by 'ipv6calcweb.cgi') - in addition, database related information can be displayed, if databases are located on the system and supported.

    $ ipv6calc -q -i -m 2a01:238:423d:8800:85b3:9e6b:3019:8909
    IPV6=2a01:0238:423d:8800:85b3:9e6b:3019:8909
    IPV6_ANON=a909:16fa:9091:a448:a909:4941:0000:0007
    IPV6_TYPE=unicast,global-unicast,productive,iid-random,iid,iid-local
    IPV6_COUNTRYCODE=DE
    IPV6_COUNTRYCODE_SOURCE=GeoIP
    IPV6_AS_NUM=6724
    IPV6_AS_TEXT=AS6724 STRATO AG
    IPV6_REGISTRY=RIPENCC
    SLA=8800
    IID=85b3:9e6b:3019:8909
    EUI64_SCOPE=local-random
    IP2LOCATION_COUNTRY_SHORT=DE
    IP2LOCATION_COUNTRY_LONG=Germany
    IP2LOCATION_REGION=Berlin
    IP2LOCATION_CITY=Berlin
    IP2LOCATION_LATITUDE=52.524368
    IP2LOCATION_LONGITUDE=13.410530
    IP2LOCATION_ZIPCODE=10178
    IP2LOCATION_TIMEZONE=+01:00
    GEOIP_AS_TEXT=AS6724 STRATO AG
    GEOIP_COUNTRY_SHORT=DE
    GEOIP_COUNTRY_LONG=Germany
    GEOIP_LATITUDE=51.000000
    GEOIP_LONGITUDE=9.000000
    GEOIP_CONTINENTCODE=EU
    DBIP_COUNTRY_SHORT=DE
    DBIP_CITY=Berlin
    DBIP_REGION=Berlin
    EXTERNAL_COUNTRY_SHORT=DE
    IP2LOCATION_DATABASE_INFO=IP2L-DB11 IPv6 LITE 20150329 Copyright (c) 2015 IP2Location All Rights Reserved / This site or product includes IP2Location LITE data available from http://lite.ip2location.com
    GEOIP_DATABASE_INFO=GEO-106FREE 20150407 Build 1 Copyright (c) 2015 MaxMind Inc All Rights Reserved / GEO-117 20150405 Build 1 Copyright (c) 2015 MaxMind Inc All Rights Reserved / GEO-536LITE 20150407 Build 1 Copyright (c) 2015 MaxMind Inc All Rights Reserved
    DBIP_DATABASE_INFO=DBIP-2/20150301, created: 20150304-183312 UTC / DBIP-4/20150301, created: 20150304-183330 UTC
    EXTERNAL_DATABASE_INFO=EXTDB-4/AFRINIC/20150215 APNIC/20150213 ARIN/20150215 IANA/20140520 LACNIC/20150213 RIPENCC/20150214, created: 20150215-170924 UTC
    BUILTIN_DATABASE_INFO=IPv6-REG:AFRINIC/20150418 APNIC/20150417 ARIN/20150418 IANA/20150324 LACNIC/20150417 RIPENCC/20150417
    IPV6CALC_NAME=ipv6calc
    IPV6CALC_VERSION=0.99.0
    IPV6CALC_COPYRIGHT="(P) & (C) 2001-2015 by Peter Bieringer <pb (at) bieringer.de>"
    IPV6CALC_OUTPUT_VERSION=10
    IPV6CALC_SETTINGS_ANON="set=keep-type-asn-cc,mask-ipv6=56,mask-ipv4=24,mask-eui64=40,mask-mac=24,method=keep-type-asn-cc"
    IPV6CALC_FEATURES="GeoIP GeoIPv6 IP2Location IP2Location6 DBIPv4 DBIPv6 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_IPV4_COUNTRY DB_IPV6_COUNTRY DB_IPV4_CITY DB_IPV6_CITY DB_IPV4_REGION DB_IPV6_REGION DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC"
    IPV6CALC_CAPABILITIES="GeoIP(linked) IP2Location(linked) DBIP External DB_AS_REG(BuiltIn) DB_CC_REG(BuiltIn) DB_IPV4_REG(BuiltIn) DB_IPV6_REG(BuiltIn) DB_IEEE(BuiltIn)"

Special machine readable output options (>= 0.99.0)

###### Output filter by selecting a token (>= 0.99.0)

Using option --mrst <TOKEN> (Machine Readable Select Token) can be used to display only token

    $ ipv6calc -q -i --mrst IPV6_TYPE 2a01:238:423d:8800:85b3:9e6b:3019:8909
    IPV6_TYPE=unicast,global-unicast,productive,iid-random,iid,iid-local

###### Output filter by matching token (>= 0.99.0)

Using option --mrmt <TOKEN> (Machine Readable Match Token) can be used to display only matching tokens

    $ ipv6calc -q -i --mrmt IP2LOCATION 2a01:238:423d:8800:85b3:9e6b:3019:8909
    IP2LOCATION_COUNTRY_SHORT=DE
    IP2LOCATION_COUNTRY_LONG=Germany
    IP2LOCATION_REGION=Berlin
    IP2LOCATION_CITY=Berlin
    IP2LOCATION_LATITUDE=52.524368
    IP2LOCATION_LONGITUDE=13.410530
    IP2LOCATION_ZIPCODE=10178
    IP2LOCATION_TIMEZONE=+01:00
    IP2LOCATION_DATABASE_INFO="IP2L-DB11 IPv6 LITE 20150329 Copyright (c) 2015 IP2Location All Rights Reserved / This site or product includes IP2Location LITE data available from http://lite.ip2location.com"

###### Output filter by selecting a value of a token token (>= 0.99.0)

Using option --mrtvo <TOKEN> (Machine Readable Token Value Only) can be used to display only value of a token

    $ ipv6calc -q -i --mrtvo IPV6_TYPE 2a01:238:423d:8800:85b3:9e6b:3019:8909
    unicast,global-unicast,productive,iid-random,iid,iid-local

###### Output adjustment by unconditional quoting of values (>= 0.99.0)

Using option --mrqva (Machine Readable Quote Values Always) can be used to quote values always

    $ ipv6calc -q -i --mrqva --mrtvo IPV6_TYPE 2a01:238:423d:8800:85b3:9e6b:3019:8909
    "unicast,global-unicast,productive,iid-random,iid,iid-local"

###### Output adjustment by unconditional disabling quoted values (>= 0.99.0)

Using option --mrqvn (Machine Readable Quote Values Never) can be used to never quote values

    $ ipv6calc -q -i --mrqvn --mrst IPV6_AS_TEXT 2a01:238:423d:8800:85b3:9e6b:3019:8909
    IPV6_AS_TEXT=AS6724 STRATO AG

###### Output adjustment by unconditional print token in case of empty value (>= 0.99.0)

Using option --mrstpq (Machine Readable Select Token Print Always) can be used to print always token/value regardless it's contained

    $ ipv6calc -q -i --mrqva --mrstpa IPV4 2a01:238:423d:8800:85b3:9e6b:3019:8909
    IPV4=""
    $ ipv6calc -q -i --mrqva --mrst IPV4 2a01:238:423d:8800:85b3:9e6b:3019:8909
    (no output)

#### Filter mode

“ipv6calc” can run in filter mode to be able to extract from a huge list of IPv4/IPv6 addresses ones which are interesting or ones which are not interesting (see printout of online help below).

Filter tokens are the ones which are listed on “TYPE” lines shown in “-m -i” information mode.

Example for searching for Teredo addresses:

    $ cat ip.bieringer.de-log.201310 | awk '{ print $1 }' | sort | uniq | ipv6calc -A filter -E teredo
    2001:0:9d38:90d7:34f7:1a26:8599:e079

For more information see below

Note: since version 0.95.0 '-A filter' is optional if option '-E <filter expression>' is given (autoselected action).

#### Test mode

Since 0.99.2 a test mode ('-A test', autoselected in case 'test_*' options are given) is implemented for address prefix or range

For more information see below

### Option style

Since version 0.40 new-style option handling was introduced, using

- --in <inputtype>

- --out <outputtype>

- --action <actiontype>

and many more conversions were added. A built-in check matrix should prevent misconversions.

Up to version 0.39, only old-style options (aka “shortcut” options). They are one-in-all options, specifying input/action/output in one token. Internally this options will be converted into new-style options.

### Online help

Online help always shows the currently implemented features.

#### Main online help:

External database options only appear if compiled with related support.

    $ ipv6calc -h
    ipv6calc: version 0.99.0 GeoIP GeoIPv6 IP2Location IP2Location6 DBIPv4 DBIPv6 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_IPV4_COUNTRY DB_IPV6_COUNTRY DB_IPV4_CITY DB_IPV6_CITY DB_IPV4_REGION DB_IPV6_REGION DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC
    (P) & (C) 2001-2015 by Peter Bieringer <pb (at) bieringer.de>

    This program formats and calculates IPv6/IPv4/MAC addresses and can do many more tricky things

      [-d|--debug <debug value>] : debug value (bitwise like)
                                    can also be set by IPV6CALC_DEBUG environment value
      [-v|--version [-v [-v]]]   : version information (2 optional detail levels)
      [-v|--version -h]          : explanation of feature tokens
      [-V|--verbose]             : be more verbose
      [-h|--help|-?]             : this online help

      [--disable-ip2location           ] : IP2Location support disabled
      [--db-ip2location-disable        ] : IP2Location support disabled
      [--db-ip2location-dir <directory>] : IP2Location database directory (default: /usr/share/IP2Location)
      [--db-ip2location-lib <file>     ] : IP2Location library file (default: libIP2Location.so)
      [--db-ip2location-only-type <TYPE>]: IP2Location database only selected type (1-24)
      [--db-ip2location-allow-softlinks] : IP2Location database softlinks allowed
      [--db-ip2location-lite-to-sample-autoswitch-max-delta-months <MONTHS>]:
         autoswitch from LITE to SAMPLE databases if possible and delta is not more than 12 months (0=disabled)
      [--db-ip2location-comm-to-lite-switch-min-delta-months <MONTHS>]:
         switch from COMM to LITE databases if possible and delta more than 12 months (0=disabled)

      [--disable-geoip                 ] : GeoIP support disabled
      [--db-geoip-disable              ] : GeoIP support disabled
      [--db-geoip-dir       <directory>] : GeoIP database directory (default: /usr/share/GeoIP)
      [--db-geoip-lib       <file>     ] : GeoIP library file (default: libGeoIP.so.1)

      [--disable-dbip                  ] : db-ip.com support disabled
      [--db-dbip-disable               ] : db-ip.com support disabled
      [--db-dbip-dir        <directory>] : db-ip.com database directory (default: /usr/share/DBIP)

      [--disable-external              ] : External support disabled
      [--db-external-disable           ] : External support disabled
      [--db-external-dir    <directory>] : External database directory (default: /usr/share/ipv6calc/db)

      [--disable-builtin               ] : BuiltIn support disabled
      [--db-builtin-disable            ] : BuiltIn support disabled

      [-q|--quiet]               : be more quiet (auto-enabled in pipe mode)
      [-f|--flush]               : flush each line in pipe mode

     Usage with new style options:
      [--in|-I <input type>]   : specify input  type
                                 (default: autodetect)
      [--out|-O <output type>] : specify output type
                                 (sometimes: autodetect)
      [--action|-A <action>]   : specify action
                                 (default: format conversion, sometimes: autodetect)
      [<format option> ...] : specify format options
      <input data> [...]    : input data

     Available input  types:  [-m] -I|--in     -?|-h|--help
      Available output types:  [-m] -O|--out    -?|-h|--help
      Available action types:  [-m] -A|--action -?|-h|--help

     Other usage:
      --showinfo|-i [--machine_readable|-m] : show information about input data
      --showinfo|-i --mrqva                 : Machine Readable Quote Values Always
      --showinfo|-i --mrqvn                 : Machine Readable Quote Values Never
      --showinfo|-i --mrst <TOKEN>          : Machine Readable Select Token
      --showinfo|-i --mrstpa <TOKEN>        : Machine Readable Select Token Print Always
      --showinfo|-i --mrmt <TOKENPREFIX>    : Machine Readable Match Token Prefix
      --showinfo|-i --mrtvo <TOKEN>         : Machine Readable Token Value Only
      --showinfo|-i --show-tokens           : show available tokens (aka types) on '-m'

     Usage with shortcut options: <shortcut option> [<format option> ...] <input data>
      for more information and available format options use: <shortcut option> -?|-h|--help

     -r|--addr2ip6_int (-O revnibbles.int)
      -r|--addr_to_ip6int (-O revnibbles.int)
      -a|--addr2ip6_arpa (-O revnibbles.arpa)
      -a|--addr_to_ip6arpa (-O revnibbles.arpa)
      -b|--addr_to_bitstring (-O bitstring)
         --addr2compaddr (--printcompressed)
         --addr_to_compressed (--printcompressed)
         --addr2uncompaddr (--printuncompressed)
         --addr_to_uncompressed (--printuncompressed)
         --addr_to_base85 (-I ipv6addr -O base85)
         --base85_to_addr (-I base85 -O ipv6addr)
         --mac_to_eui64 (-I mac -O eui64)
         --addr2fulluncompaddr (--printfulluncompressed)
         --addr_to_fulluncompressed (--printfulluncompressed)
         --addr2if_inet6 (-I ipv6addr -O ifinet6)
         --addr_to_ifinet6 (-I ipv6addr -O ifinet6)
         --if_inet62addr (-I ifinet6 -O ipv6addr --printcompressed)
         --ifinet6_to_compressed (-I ifinet6 -O ipv6addr --printcompressed)
         --eui64_to_privacy (-I iid_token -O iid_token -A genprivacyiid)
         --ipv4_to_6to4addr (-I ipv4 -O ipv6addr -A conv6to4)

#### Database options

- each internal/external database can be disabled by option

- directory of database files can be given via related option

- databases requiring external library the library file can be given in case of dynamic load and linking

##### IP2Location

IP2location database directory can contain a bunch of files, the best ones are selected automatically (since 0.99.0). “Best” can be controlled via two options:

- --db-ip2location-lite-to-sample-autoswitch-max-delta-months <MONTHS>: switches from LITE to SAMPLE databases in case of

  - existing SAMPLE database

  - SAMPLE database not older than default/given MONTHS than the LITE database

  - IP address is in range of SAMPLE database (IPv4: 0.0.0.0-99.255.255.255, IPv6: 2a04::/16)

  - autoswitch can be disabled by using MONTHS=0

  - reason for implementation: show maximum possible IP2Location features

- --db-ip2location-comm-to-lite-switch-min-delta-months <MONTHS>: switches from COMMercial to LITE databases in case of

  - existing LITE database

  - COMMercial database is default/given MONTHS older than the LITE database

  - switch can be disabled by using MONTHS=0

  - reason for implementation: avoid using old COMMercial databases

- --db-ip2location-only-type <TYPE>: only selects databases of given type

  - reason for implementation: be able to select a specific database type

- --db-ip2location-allow-softlinks: allow softlinked IP2Location database files

  - by default, softlinked database files are skipped, because it's hard to detect whether one is COMMercial, LITE or SAMPLE

use “ipv6calc -vv” or “ipv6calc -vvv” for verification, which databases are selected finally.

#### Input-type options

    $ ipv6calc --in -?
    ipv6calc: version 0.97.0 IP2Location GeoIP GeoIPv6 DB_AS DB_IPV4 DB_IPV6 DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC
    (P) & (C) 2001-2014 by Peter Bieringer <pb (at) bieringer.de>

     Available input types:
      auto            : automatic detection
      revnibbles.int  : dot separated nibbles reverse, ending with ip6.int.
      revnibbles.arpa : dot separated nibbles reverse, ending with ip6.arpa.
      bitstring       : bitstring labes, ending with ip6.arpa.
      ipv6addr        : IPv6 address
      ipv6literal     : IPv6 address in literal
      ipv4addr        : IPv4 address
      ipv4hex         : IPv4 in hexdecimal format
      ipv4revhex      : IPv4 in byte-reversed hexdecimal format
      mac             : MAC address (48 bits)
      eui64           : EUI-64 identifier (64 bits)
      base85          : Base-85 string
      ifinet6         : Like line in /proc/net/if_inet6
      iid+token       : Interface identifier and token
      ipv6logconv     : ipv6logconv (currently not supported)
      prefix+mac      : IPv6 prefix and a MAC address
      asn             : Autonomous System Number

#### Output-type options:

    $ ipv6calc --out -?
    ipv6calc: version 0.97.0 IP2Location GeoIP GeoIPv6 DB_AS DB_IPV4 DB_IPV6 DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC
    (P) & (C) 2001-2014 by Peter Bieringer <pb (at) bieringer.de>

     Available output types:
      revnibbles.int  : dot separated nibbles reverse, ending with ip6.int.
      revnibbles.arpa : dot separated nibbles reverse, ending with ip6.arpa.
      bitstring       : bitstring labes, ending with ip6.arpa.
      ipv6addr        : IPv6 address
      ipv4addr        : IPv4 address
      mac             : MAC address (48 bits)
      eui64           : EUI-64 identifier (64 bits)
      base85          : Base-85 string
      ifinet6         : Like line in /proc/net/if_inet6
      iid             : Interface identifier
      iid+token       : Interface identifier and token
      addrtype        : Address type
      ouitype         : OUI (IEEE) type
      ipv6addrtype    : IPv6 address type
      any             : any type (currently not supported)
      revipv4         : reverse IPv4, ending with in-addr.arpa
      ipv4hex         : IPv4 in hexdecimal format
      octal           : IP address in escaped octal format
      hex             : IP address in hexadecimal format
      ipv6literal     : IPv6 address in literal

     For examples and available format options use:
        -O|--out <type> --examples

#### Action-type options:

    $ ipv6calc --action -?
    ipv6calc: version 0.99.1 IP2Location GeoIP GeoIPv6 DB_AS DB_IPV4 DB_IPV6 DB_IPV4_AS DB_IPV6_AS DB_IPV4_CC DB_IPV6_CC DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC
    (P) & (C) 2001-2015 by Peter Bieringer <pb (at) bieringer.de>

     Available action types:
      auto             : Automatic selection of action (default)
      geneui64         : Converts a MAC address to an EUI-64 address
      conv6to4         : Converts IPv4 address <-> 6to4 IPv6 address (prefix)
      convnat64        : Converts IPv4 address <-> NAT64 IPv6 address
      genprivacyiid    : Generates a privacy interface ID out of a given one (arg1) and a token (arg2)
      prefixmac2ipv6   : Generates an IPv6 address out of a prefix and a MAC address
      anonymize        : Anonymize IPv4/IPv6 address without loosing much information
      6rd_local_prefix : Calculate the 6rd prefix from given IPv6 prefix (& relay prefix) and IPv4
                          Options:
                           --6rd_prefix ... (required)
                           --6rd_relay_prefix ... (optional)
      6rd_extract_ipv4 : Extract from 6rd address the include IPv4 address
                          Options:
                           --6rd_prefixlength ... (required)
      filter           : Filter addresses related to filter options

#### Special action “filter”:

Special action “filter” can be used especially in pipe mode to filter IP addresses related to their type and since 0.99.0 also related to database results (CountryCode, ASN or Registry).

    $ ipv6calc: version 0.99.2 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE
     Filter given addresses from stdin by filter expression, e.g.
      echo '2001:db8::1' | ipv6calc [-A filter] -E iid-local
      echo '2001:db8::1' | ipv6calc [-A filter] -E iid-local,global-unicast
      echo '2001:db8::1' | ipv6calc [-A filter] -E ^iid-random
     (note: since version 0.95.0 '-A filter' is autoselected if option '-E <filter expression>' is given)
     negation of filter expression with prefix: ^
      IPv6 address filter tokens:
       ipv6  unknown unicast multicast anycast loopback link-local site-local compat-v4 mapped reserved unique-local-unicast anonymized-iid anonymized-prefix 6to4 6bone global-unicast unspecified solicited-node productive 6to4-microsoft teredo orchid link-local-teredo nat64 iid-random iid iid-local iid-global iid-teredo iid-eui48 iid-eui64 iid-isatap iid-includes-ipv4
      IPv4 address filter tokens:
       ipv4  any unicast multicast anycast broadcast loopback unspecified unknown reserved zeroconf site-local anonymized global 6to4relay
      IPv4/v6 address filter tokens based on databases:
       [^][ipv4.|ipv6.]db.cc=<CC>|unknown (Country Code [2 chars])
       [^][ipv4.|ipv6.]db.asn=<ASN>|unknown (Autonomous System Number)
       [^][ipv4.|ipv6.]db.reg=<REGISTRY>
        Registry tokens: 6BONE IANA APNIC ARIN RIPENCC LACNIC AFRINIC 6TO4 reserved unknown
      IPv4/v6 address filter tokens based on address/mask:
       [^]ipv4.addr=<IPV4-ADDRESS>[<PREFIX-LENGTH>]
       [^]ipv6.addr=<IPV6-ADDRESS>[<PREFIX-LENGTH>]
      IPv4/v6 address filter tokens based on address ranges (<=|<|>|>=):
       [^]ipv4.addr(<=|<|>|>=)<IPV4-ADDRESS>
       [^]ipv6.addr(<=|<|>|>=)<IPV6-ADDRESS>
       as alternative in case <|> creating problems also supported: =(le|lt|gt|ge)=:
       [^]ipv4.addr=(le|lt|gt|ge)=<IPV4-ADDRESS>
       [^]ipv6.addr=(le|lt|gt|ge)=<IPV6-ADDRESS>
      EUI-48/MAC address filter tokens:
        IMPLEMENTATION MISSING
      EUI-64 address filter tokens:
        IMPLEMENTATION MISSING

Example for some filter expressions:

    $ cat ip.bieringer.de-log.201504 | ipv6calc -E ipv6.db.cc=DE | wc -l
    5068

    $ cat ip.bieringer.de-log.201504 | ipv6calc -E ipv6.db.cc=US | wc -l
    305

    $ cat ip.bieringer.de-log.201504 | ipv6calc -E ipv6.db.reg=ARIN | wc -l
    306

    $ cat ip.bieringer.de-log.201504 | ipv6calc -E iid-random | wc -l
    4806

    $ cat ip.bieringer.de-log.201504 | ipv6calc -E ipv6.db.cc=US,iid-random | wc -l
    16

    $ cat ip.bieringer.de-log.201504 | ipv6calc -A filter -E ipv6.db.cc=US,iid-random,ipv4.db.cc=US | wc -l
    1842

    $ cat ip.bieringer.de-log.201504 | ipv6calc -A filter -E db.asn=8767 | wc -l
    2363
    $ cat ip.bieringer.de-log.201504 | ipv6calc -A filter -E ipv6.db.asn=8767 | wc -l
    1452
    $ cat ip.bieringer.de-log.201504 | ipv6calc -A filter -E ipv4.db.asn=8767 | wc -l
    911

Example for searching for addresses in a specific range (supported since 0.99.2):

    $ cat ip.bieringer.de-log.201609 | awk '{ print $1 }' | sort | uniq | ipv6calc -E ipv6.addr=ge=2002::,ipv6.addr=lt=2003::
    2002:2518:0:1:2:3:4:5
    ...
    2002:d950:0:1:2:3:4:5

#### Special action “test”:

Special action “test” (since 0.99.2) can be used in command line or pipe mode (single address only) to test IP addresses related to a given prefix or range .

    $ ./ipv6calc/ipv6calc -A test -h
    ipv6calc: version 0.99.2 DB_AS_REG DB_IPV4_REG DB_IPV6_REG DB_CC_REG DB_IEEE ANON_ZEROISE ANON_ANONYMIZE

     Test given address(es) against supported tests:
      --test_prefix <PREFIX>       : inside a prefix
      --test_gt|--test_ge <ADDRESS>: greater(/equal) than an address
      --test_lt|--test_le <ADDRESS>: less(/equal) than an address

     Test given address(es) from stdin, e.g.
      echo '2001:db8::1' | ipv6calc [-A test] --test_prefix 2001:db8::/32
      echo '2001:db8::1' | ipv6calc [-A test] --test_prefix 2001:db9::/32

     Single address test, return code: 0=inside/matching 1=outside/not-matching 2=uncomparable
      ipv6calc [-A test] --test_prefix 2001:db8::/32 2001:db8::1
      ipv6calc [-A test] --test_prefix 2001:db9::/32 2001:db8::1
      ipv6calc [-A test] --test_ge 2001:db8:: --test_le 2001:db8:ffff:ffff:ffff:ffff:ffff:ffff 2001:db8::1
      ipv6calc [-A test] --test_ge 2001:db9:: --test_le 2001:db9:ffff:ffff:ffff:ffff:ffff:ffff 2001:db8::1
      ipv6calc [-A test] --test_ge 2001:db9:: --test_lt 2001:dba:: 2001:db8::1
      ipv6calc [-A test] --test_ge 2001:db8:: --test_lt 2001:db9:: 2001:db8::1

Example for command line mode:

    $ ipv6calc --test_ge 2001:db8:: --test_le 2001:db8:ffff:ffff:ffff:ffff:ffff:ffff 2001:db8::1; echo $?
    no input type specified, try autodetection...found type: ipv6addr
    no output type specified, try autodetection...found type: ipv6addr
    2001:db8::1   greater/equal than 2001:db8::  less/equal than 2001:db8:ffff:ffff:ffff:ffff:ffff:ffff
    0

Example for command line mode (quiet):

    $ ipv6calc -q --test_ge 2001:db8:: --test_le 2001:db8:ffff:ffff:ffff:ffff:ffff:ffff 2001:db8::1; echo $?
    2001:db8::1   greater/equal than 2001:db8::  less/equal than 2001:db8:ffff:ffff:ffff:ffff:ffff:ffff
    0

Example for pipe mode:

    $ echo -e "1.2.3.4\n1.2.4.4" | ipv6calc --test_prefix 1.2.3.0/24
    1.2.3.4   inside 1.2.3.0/24
    1.2.4.4   NOT inside 1.2.3.0/24

## Webserver log conversion helper program "ipv6logconv"

This program parses address tokens of a given webserver logfile and converts them to special strings, useful for statistics (e.g. created by using "analog").

### Supported options

    $ ipv6logconv -h
    ipv6logconv: version 0.97.0 CONV_REG CONV_IEEE
    (P) & (C) 2002-2014 by Peter Bieringer <pb (at) bieringer.de>
     General:
      [-d|--debug <debug value>] : debug value (bitwise like)
      [-q|--quiet] : be more quiet
      [-n|--nocache] : disable caching
      [-c|--cachelimit <value>] : set cache limit
                                   default: 20
                                   maximum: 200
     Output:
      [--out <output type>] : specify output type
       addrtype       : Address type
       ouitype        : OUI (IEEE) type
       ipv6addrtype   : IPv6 address type
       any            : any type
     Takes data from stdin, proceed it to stdout

### Examples

A demonstration about which kind of statistics are possible to produce is shown at http://www.ipv6.bieringer.de/ (IPv6 only).

### Usage

Example:

    $ echo "2002:50b5:7940:0000:0000:0000:50b5:7940 - -" | ipv6logconv -q --out any
    RIPENCC.6to4.global-unicast.ipv6-addr.addrtype.ipv6calc

See more examples inside the package.

## Webserver log anonymization helper program "ipv6loganon"

On autoconfiguration, the interface part of an IPv6 address is based on the MAC address of the network interface card (NIC). This address is used for outgoing requests, if privacy option (RFC3041 / RFC4941) is not enabled. This results in many privacy related information on web- or mail-server log files. Administrators, which won't (be allowed to) store such information over time, but still do not want to loose information about address type distribution should use 'ipv6loganon' to anonymize their log files.

Since version 0.94.0 internally also IID anonymization is possible without loosing any information for “ipv6logstats”.

Since version 0.95.0 internally also prefix anonymization is possible without loosing any information for “ipv6logstats”.

### Anonymization details

#### Method “zeroize”

The anonymizer would keep as much information as possible for IPv6 address types.

Client-side IID would be anonymized by

- EUI-48 based: serial number would be zero'ed, keeping OID

- EUI-64 based: serial number would be zero'ed, keeping OID

- ISATAP: client IPv4 address would be anonymized by given IPv4 mask

- TEREDO: client IPv4 address would be anonymized by given IPv4 mask, client port would be zero'ed

- 6to4(Microsoft): client IPv4 address would be anonymized by given IPv4 mask

- local: whole IID would be zero'ed

Client-side SLA would be anonymized by

- SLA would be zero'ed

Prefix would be anonymized by

- 6to4: client IPv4 address would be anonymized by given IPv4 mask

Compat/Mapped IPv4 addresses would be anonymized by

- IPv4 address would be anonymized by given IPv4 mask

#### Method “anonmize”

The anonymizer would keep as much information as possible for the IID of an IPv6 address.

Description from libipv6addr.h:

     * IID anonymization is done by replacing with related information (64-bit)
     * xxxx:xxxx:xxxx:xxxC  (C = 4-bit checksum)
     *
     * a9p9 4941 0000 000C  -> RFC 4941 anonymized privacy extension Interface ID
     *
     * a9p9 4291 4xxx xxxC  -> RFC 4291 anonymized EUI-48 Interface ID, xxx xxx = converted OUI
     * a9p9 4291 5xxx xxxC  -> RFC 4291 anonymized EUI-48 Interface ID, xxx xxx = converted mapped IAB/OUI-36
     * a9p9 4291 6xxx xxxC  -> RFC 4291 anonymized EUI-64 Interface ID, xxx xxx = converted OUI
     * a9p9 4291 7xxx xxxC  -> RFC 4291 anonymized EUI-64 Interface ID, xxx xxx = converted mapped IAB/OUI-36
     * a9p9 4291 8xxx xxxC  -> RFC 4291 embedded anonymized IPv4 address, xxx xxx = first 24 bit of included (anonymized) IPv4 address
     * a9p9 4291 c02d 5d1C  -> RFC 4291 Chapter 2.5.1 anonymized static Interface ID
     *
     * a9p9 5214 4xxx xxxC  -> RFC 5214 anonymized ISATAP Interface ID, xxx xxx = first 24 bit of included (anonymized) IPv4 address (local scope)
     * a9p9 5214 5xxx xxxC  -> RFC 5214 anonymized ISATAP Interface ID, xxx xxx = first 24 bit of included (anonymized) IPv4 address (global scope)
     * a9p9 5214 cxx0 000C  -> RFC 5214 anonymized ISATAP Interface ID, xx      = first  8 bit of included vendor ID (local scope)
     * a9p9 5214 dxx0 000C  -> RFC 5214 anonymized ISATAP Interface ID, xx      = first  8 bit of included vendor ID (global scope)
     * a9p9 5214 exxx xxxC  -> RFC 5214 anonymized ISATAP Interface ID, xxx xxx = first 24 bit of included extension ID (local scope)
     * a9p9 5214 fxxx xxxC  -> RFC 5214 anonymized ISATAP Interface ID, xxx xxx = first 24 bit of included extension ID (global scope)
     *
     * a9p9 4843 0000 000C  -> RFC 4843 anonymized ORCHID hash

Depending on given mask, the part of the prefix will be replaced:

     * SLA/NLA prefix part anonymization is done by replacing with pattern a909a909
     *   p = number of nibbles anonymized

#### Method “keep-type-asn-cc”

In addition to “anonymize” (of IID) this method anonymizes also the prefix of an IPv6 address or a whole IPv4 address by keeping ASN (Autonomous System Number, Country Code and Type).

Description from libipv6addr.h:

     * Prefix anonymization in case of method=kp: p=0x0f
     * a909:ccca:aaaa:aaaC  (C = 4-bit checksum)
     *                      ccc      -> 10-bit Country Code mapping [A-Z]*[A-Z0-9] (936)
     *                                   0x3FD = LISP
     *                                   0x3FE = unknown country
     *                                   0x3FF - 16 + REGISTRY_6BONE && ASN=0 = 6bone
     *                                   0x000-0x3A7: c1= c / 36, c2 = c % 36
     *                      aaaaaaaa -> 32-bit ASN

Description from libipv4addr.h:

     *  Global IPv4 addresses are anoymized by storing country code and AS number
     *   and using prefix of experimental range (240-255.x.y.z)
     *
     *  3 3 2 2 2 2 2 2 2 2 2 2 1 1 1 1 1 1 1 1 1 1
     *  1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0 9 8 7 6 5 4 3 2 1 0
     *  1 1 1 1
     * |p p p p|
     *  Prefix
     *    0xF
     *
     * Pariy Bit (odd parity)
     *         |P|
     *
     * Mapping of Country Code
     *           |c c c c c c c c c c|
     *            10-bit Country Code mapping [A-Z]*[A-Z0-9] (936)
     *            0x3FF = unknown country
     *            0x000-0x3A7: c1= c / 36, c2 = c % 36
     *
     * Mapping of ASN <= 65535
     *                                0|a a a a a a a a a a a a a a a a|
     *                                    16-bit ASN
     *
     * Mapping of ASN >= 65536, ASN & 0xE000 == 0 (12-bit LSB is ok)
     *                                1|r r r|0|l l l l l l l l l l l l|
     *                                           13-bit LSB of ASN
     *
     * Mapping of ASN >= 65536, ASN & 0xE000 != 0 (12-bit LSB overflow) => unspecified
     *                                1|r r r|1|0 0 0 0 0 0 0 0 0 0 0 0|
     *
     * Mapping of ASN registry for ASN >= 65536
     *                                  0 0 0 = "unknown ASN registry"
     *                                  0 1 0 = APNIC
     *                                  0 1 1 = RIPE
     *                                  1 0 0 = LACNIC
     *                                  1 0 1 = AFRINIC
     *                                  1 1 0 = ARIN
     * Mapping of LISP
     *                                1|r r r|1|1|0 0 0 0 0 0 0 0 0 0 0|

### Supported log file formats

Currently native supported log files:

- Apache log file format, 1st token is IPv4 or IPv6 address

There are plans to support also mail server log files sometimes in the future, but because of different formats, this would be probably done by a Perl program which parses the log file and a (cached) 'ip6calc' call with action 'anonymize'.

### Supported options

    $ ipv6loganon -h
    ipv6loganon: version 0.97.0 ANON_ZEROISE ANON_ANONYMIZE ANON_KEEP-TYPE-ASN-CC
    (P) & (C) 2007-2014 by Peter Bieringer <pb (at) bieringer.de>

    This program anonymizes IPv4/IPv6 addresses in e.g. HTTP server log files

      [-d|--debug <debug value>] : debug value (bitwise like)
                                    can also be set by IPV6CALC_DEBUG environment value
      [-v|--version [-v [-v]]]   : version information (2 optional verbose levels)
      [-h|--help|-?]             : this online help

      [--db-ip2location-disable        ] : IP2Location support disabled
      [--db-ip2location-dir <directory>] : IP2Location database directory (default: /usr/share/IP2Location)
      [--db-ip2location-lib <file>]      : IP2Location library file (default: libIP2Location.so)

      [--db-geoip-disable              ] : GeoIP support disabled
      [--db-geoip-dir       <directory>] : GeoIP database directory (default: /usr/share/GeoIP)
      [--db-geoip-lib       <file>]      : GeoIP library file (default: libGeoIP.so.1)

      [-w|--write]               : write output to file instead of stdout
      [-a|--append]              : append output to file instead of stdout
      [-f|--flush]               : flush output after each line
      [-V|--verbose]             : be verbose
      [-n|--nocache]             : disable caching
      [-c|--cachelimit <value>]  : set cache limit
                                   default: 20
                                   maximum: 200

      Shortcut for anonymization presets:
       --anonymize-standard (default)
       --anonymize-careful
       --anonymize-paranoid

      Supported methods [--anonymize-method METHOD]:
       anonymize : reliable anonymization, keep as much type information as possible
       zeroize   : simple zeroizing according to given masks, probably loose type information
       keep-type-asn-cc: special reliable anonymization, keep type & Autonomous System Number and CountryCode

      Available presets (shortcut names) [--anonymize-preset PRESET-NAME]:
       anonymize-standard   (as): mask-ipv6= 56 mask-ipv4=24 mask-eui64=40 mask-mac=24 mask-autoadjust=yes method=anonymize
       anonymize-careful    (ac): mask-ipv6= 48 mask-ipv4=20 mask-eui64=24 mask-mac=24 mask-autoadjust=yes method=anonymize
       anonymize-paranoid   (ap): mask-ipv6= 40 mask-ipv4=16 mask-eui64= 0 mask-mac=24 mask-autoadjust=no  method=anonymize
       zeroize-standard     (zs): mask-ipv6= 56 mask-ipv4=24 mask-eui64=40 mask-mac=24 mask-autoadjust=yes method=zeroize
       zeroize-careful      (zc): mask-ipv6= 48 mask-ipv4=20 mask-eui64=24 mask-mac=24 mask-autoadjust=yes method=zeroize
       zeroize-paranoid     (zp): mask-ipv6= 40 mask-ipv4=16 mask-eui64= 0 mask-mac=24 mask-autoadjust=no  method=zeroize
       keep-type-asn-cc     (kp): mask-ipv6= 56 mask-ipv4=24 mask-eui64=40 mask-mac=24 mask-autoadjust=yes method=keep-type-asn-cc

      Custom control:
      --mask-ipv4  <bits>     : mask IPv4 address [0-32] (even if occurs in IPv6 address)
      --mask-ipv6  <bits>     : mask IPv6 prefix [0-64] (only applied to related address types)
      --mask-eui64 <bits>     : mask EUI-64 address or IPv6 interface identifier [0-64]
      --mask-mac   <bits>     : mask MAC address [0-48]
      --mask-autoadjust yes|no: autoadjust mask to keep type/vendor information regardless of less given mask

     Takes data from stdin, outputs the processed data to stdout (default)

### Usage

#### Offline anonymization

    $ cat /path/to/http_log | ./ipv6loganon >/path/to/http_log_anonymized

#### On-the-fly online anonymization for Apache Webserver

> Note: since 0.91.1 also an module for Apache Webserver is available (see below) supporting anonymized logging

(Supported since 0.90.0)

Adjust or add (note: more than one CustomLog directive is supported by Apache) httpd.conf like following:

    CustomLog "|/usr/local/bin/ipv6loganon -a -f /var/log/httpd/access_log" combined

In case of “cronolog” is used on the system, configure like this:

- Apache version < 2.4:

    CustomLog "|/usr/bin/ipv6loganon -f |/usr/sbin/cronolog /var/log/httpd/access.log-%Y%m%d" combined

- Apache version >= 2.4:

    CustomLog "|$/usr/bin/ipv6loganon -f |/usr/sbin/cronolog /var/log/httpd/access.log-%Y%m%d" combined

## External database update helper scripts

The “tools” subdirectory contains helper scripts for updating external databases.

### IP2Location

    $ /usr/share/ipv6calc/tools/IP2Location-update.sh -h
    Usage: IP2Location-update.sh [-D <dir>] [-n] [-s]
    	-D <dir>	database destination directory (optional)
    	-n		no action (dry-run)
    	-s		skip already successfully downloaded files

    	database directory: /usr/share/IP2Location (default: /usr/share/IP2Location)

    	it honors externally defined environment value: IP2LOCATION_DAT_DIR

     this script will download data from ip2location.com
      into given/set database directory

     Sample databases:
      IP2LOCATION_DAT_FILES_SAMPLE=IPv4:20 IPv6:20 IPv4:24 IPv6:24

     Lite (free) databases:
      IP2LOCATION_DAT_FILES_LITE_FREE=IPv4:1 IPv6:1

     With authentication (requires login/password in /home/compile/.ip2location) and a valid subscription
      IP2LOCATION_DAT_FILES_LITE=

     Credentials must be defined in $HOME/.ip2location by
      login=IP2LOCATION-LOGIN
      password=IP2LOCATION-PASSWORD

     In addition settings from above can be overwritten by setting related variables

### GeoIP

    $ /usr/share/ipv6calc/tools/GeoIP-update.sh -h
    Usage: GeoIP-update.sh [-D <dir>]
    	-D <dir>	database directory (optional)

    	database directory: /usr/share/GeoIP (default: /usr/share/GeoIP)

    	it honors externally defined environment value: GEOIP_DAT_DIR

     this script will download data from geolite.maxmind.com (GeoIP)
     into given/set database directory

     GEOIP_DAT_URL_BASE=http://geolite.maxmind.com/download/geoip/database/
     GEOIP_DAT_FILES=GeoLiteCountry/GeoIP.dat.gz GeoIPv6.dat.gz GeoLiteCity.dat.gz GeoLiteCityv6-beta/GeoLiteCityv6.dat.gz asnum/GeoIPASNum.dat.gz asnum/GeoIPASNumv6.dat.gz

### DB-IP.com

    $ /usr/share/ipv6calc/tools/DBIP-update.sh -h
    Usage: DBIP-update.sh [-s] [-D <dir>]
    	-s		skip download
    	-D <dir>	database directory (optional)

    	database directory: /usr/share/DBIP (default: /usr/share/DBIP)

     it honors externally defined environment value: DBIP_DAT_DIR

     this script (and its helper scripts) will download data from
     DB-IP.com (free versions) and generate Berkeley DB files for ipv6calc
     "DBIP" database support

     DBIP_DAT_URL_BASE=http://download.db-ip.com/free/
     DBIP_DAT_FILES=dbip-country-%Y-%m.csv.gz dbip-city-%Y-%m.csv.gz

### External

    $ /usr/share/ipv6calc/tools/ipv6calc-db-update.sh -h
    Usage: ipv6calc-db-update.sh [-s] [-u] [-D <dir>]
    	-s		skip download
    	-u		unconditional update
    	-D <dir>        database directory (optional)

    	database directory: /usr/share/ipv6calc/db (default: /usr/share/ipv6calc/db)

    	it honors externally defined environment value: IPV6CALC_DAT_DIR

    	this script (and its helper scripts) will download data from
    	registries and generate Berkeley DB files for ipv6calc
    	"external" database support

## Perl CGI wrapper program "ipv6calcweb.cgi"

Because calling C programs directly as CGI isn't really recommended (too much security troubles all the time), I wrote a small wrapper utility which calls "ipv6calc" to get information about client and server address for displaying on a web page.

### Examples

A demonstration about which kind of output is possible to produce is shown at

- http://ip.bieringer.de/ (IPv4/IPv6)

- http://www.ipv6.bieringer.de/ (IPv6 only)

- http://mirrors.bieringer.de/ (IPv4/IPv6)

- http://www.sixxs.net/tools/ipv6calc/ (IPv4/IPv6)

## Webserver log statistics helper program "ipv6logstats"

This program parses a given webserver logfile and count addresses, useful for time period statistics.

Since version 0.95.0 it has extended output, adding a date/time line and statistics by Country Code and ASN (if required databases are available).

### Supported options

    $ ./ipv6logstats -h
    ipv6logstats: version 0.97.0 STAT_REG STAT_CC STAT_AS
    (P) & (C) 2003-2014 by Peter Bieringer <pb (at) bieringer.de>

     Takes web server log data (or any other data which has IPv4/v6 address in first column)
       from stdin and print statistics table/list (depending on option) to stdout

      [-d|--debug <debug value>] : debug value (bitwise like)
                                    can also be set by IPV6CALC_DEBUG environment value
      [-v|--version [-v [-v]]]   : version information (2 optional verbose levels)
      [-h|--help|-?]             : this online help

      [--db-ip2location-disable        ] : IP2Location support disabled
      [--db-ip2location-dir <directory>] : IP2Location database directory (default: /usr/share/IP2Location)
      [--db-ip2location-lib <file>]      : IP2Location library file (default: libIP2Location.so)

      [--db-geoip-disable              ] : GeoIP support disabled
      [--db-geoip-dir       <directory>] : GeoIP database directory (default: /usr/share/GeoIP)
      [--db-geoip-lib       <file>]      : GeoIP library file (default: libGeoIP.so.1)

      [-u|--unknown]             : print unknown IP addresses to stderr
      [-c|--columns]             : print statistics in columns (1)
      [-n|--noheader]            : don't print header in columns mode (1)
      [-o|--onlyheader]          : print only header in columns mode (1)
      [-p|--prefix <token>]      : print token as prefix (1)
      [-q|--quiet]               : be more quiet
      [-s|--simple]              : disable extended statistic (CountryCode/ASN)

     (1) unsupported for CountryCode & ASN statistics

### Usage

There are a README and some helper scripts available in the package how to use this program and how to generate a graph using Gnuplot.

#### Line-by-line output

The example shows output version 3.0, which

    $ zcat ip.bieringer.de-log.201*.gz | ipv6logstats

Header section, since output version 3.0 (>= 0.95.0) additional lines starting with '*3*' and '*DateTime' and '*UnixTime' included

    *Version             3.0
    *DateTime: 2013:11:03 08:57:01+0000 GMT
    *UnixTime: 1383469021
    *3*DB-Info: DB features: 0x0000133f
    *3*DB-Info: GeoIP: features: 0x00000330
    *3*DB-Info: GeoIP: info of available databases in directory: /usr/share/GeoIP (max: 31)
    *3*DB-Info: GeoIP: GeoIP Country Edition            :[ 1] /usr/share/GeoIP/GeoIP.dat               (GEO-106FREE 20130903 Build 1 Copyright (c) 2013 MaxMind Inc All Rights Reserved)
    *3*DB-Info: GeoIP: GeoIP ASNum Edition              :[ 9] /usr/share/GeoIP/GeoIPASNum.dat          (GEO-117 20130902 Build 1 Copyright (c) 2013 MaxMind Inc All Rights Reserved)
    *3*DB-Info: GeoIP: GeoIP Country V6 Edition         :[12] /usr/share/GeoIP/GeoIPv6.dat             (GEO-106FREE 20131001 Build 1 Copyright (c) 2013 MaxMind Inc All Rights Reserved)
    *3*DB-Info: GeoIP: GeoIP Large Country Edition      :[17] /usr/share/GeoIP/GeoIP.dat               (GEO-106FREE 20130903 Build 1 Copyright (c) 2013 MaxMind Inc All Rights Reserved)
    *3*DB-Info: GeoIP: GeoIP Large Country V6 Edition   :[18] /usr/share/GeoIP/GeoIPv6.dat             (GEO-106FREE 20131001 Build 1 Copyright (c) 2013 MaxMind Inc All Rights Reserved)
    *3*DB-Info: GeoIP: GeoIP ASNum V6 Edition           :[21] /usr/share/GeoIP/GeoIPASNumv6.dat        (GEO-117 20130306 Build 1 Copyright (c) 2013 MaxMind Inc All Rights Reserved)
    *3*DB-Info: IP2Location: features: 0x00000300
    *3*DB-Info: IP2Location: info of available databases in directory: /usr/share/IP2Location
    *3*DB-Info: IP2Location: IPv4 Country               : /usr/share/IP2Location/IP-COUNTRY.BIN    (IP2L-DB20 20130411 Copyright (c) 2013 IP2Location All Rights Reserved)
    *3*DB-Info: IP2Location: IPv6 Country               : /usr/share/IP2Location/IPV6-COUNTRY.BIN  (IP2L-DB1 20131025 Copyright (c) 2013 IP2Location All Rights Reserved)
    *3*DB-Info: BuiltIn: features: 0x0000100f
    *3*DB-Info: BuiltIn: info of available databases
    *3*DB-Info: BuiltIn: ASN  : IANA/20130730
    *3*DB-Info: BuiltIn: CC   : AFRINIC/20130806 APNIC/20130805 ARIN/20130805 LACNIC/20130805 RIPENCC/20130805
    *3*DB-Info: BuiltIn: IPv4 : AFRINIC/20131014 APNIC/20131014 ARIN/20131014 IANA/20130520 LACNIC/20131014 RIPENCC/20131014
    *3*DB-Info: BuiltIn: IPv6 : AFRINIC/20131015 APNIC/20131014 ARIN/20131014 IANA/20130215 LACNIC/20131014 RIPENCC/20131014
    *3*DB-Info: BuiltIn: IEEE : IAB/20131015 OUI/20131015 OUI36/20131015

Simple statistics section

    ALL                  108525
    IPv4                 46233
    IPv6                 62292
    UNKNOWN              0
    IPv4/APNIC           2397
    IPv4/ARIN            3525
    IPv4/RIPE            40198
    IPv4/LACNIC          97
    IPv4/UNKNOWN         16
    IPv6/6bone           0
    IPv6/IANA            0
    IPv6/APNIC           129
    IPv6/ARIN            839
    IPv6/RIPE            61074
    IPv6/LACNIC          0
    IPv6/RESERVED        0
    IPv6/UNKNOWN         0
    IPv6/6to4/IANA       0
    IPv6/6to4/APNIC      0
    IPv6/6to4/ARIN       16
    IPv6/6to4/RIPE       51
    IPv6/6to4/LACNIC     0
    IPv6/6to4/RESERVED   0
    IPv6/6to4/UNKNOWN    0
    IPv6/Teredo/IANA     0
    IPv6/Teredo/APNIC    63
    IPv6/Teredo/ARIN     0
    IPv6/Teredo/RIPE     90
    IPv6/Teredo/LACNIC   30
    IPv6/Teredo/RESERVED 0
    IPv6/Teredo/UNKNOWN  0
    IPv6/NAT64/IANA      0
    IPv6/NAT64/APNIC     0
    IPv6/NAT64/ARIN      0
    IPv6/NAT64/RIPE      0
    IPv6/NAT64/LACNIC    0
    IPv6/NAT64/RESERVED  0
    IPv6/NAT64/UNKNOWN   0
    IPv6/IID/Global      1436
    IPv6/IID/Random      58198
    IPv6/IID/Manual      2055
    IPv6/IID/ISATAP      353
    IPv6/IID/Unknown     0

External database supported output since output version 3.0 (>= 0.95.0)

- Country Code / Proto

    ...
    *3*CC-code-proto/DE/ALL   96450
    *3*CC-code-proto/DE/IPv4  36486
    *3*CC-code-proto/DE/IPv6  59964
    *3*CC-code-proto-list/DE  96450 36486 59964
    ...

- Proto / Country Code (“ALL” line contains: ALL IPv4 IPv6)

    ...
    *3*CC-proto-code/ALL/DE   96450
    *3*CC-proto-code/IPv4/DE  36486
    *3*CC-proto-code/IPv6/DE  59964
    ...
    *3*CC-proto-code-list/ALL  108525 46483 62042

- Autonomous System number / Proto

    ...
    *3*AS-num-proto/8767/ALL   6054
    *3*AS-num-proto/8767/IPv4  2705
    *3*AS-num-proto/8767/IPv6  3349
    *3*AS-num-proto-list/8767  6054 2705 3349
    ...

- Proto / Autonomous System number (“ALL” line contains: ALL IPv4 IPv6)

    ...
    *3*AS-proto-num/ALL/8767   6054
    *3*AS-proto-num/IPv4/8767  2705
    *3*AS-proto-num/IPv6/8767  3349
    ...
    *3*AS-proto-num-list/ALL  108525 46483 62042

#### Column output

Column output does not support version 3 extension, only simple statistics with a header line:

    $ zcat ip.bieringer.de-log.201*.gz | ipv6logstats -q -c
     IPv4 IPv6 UNKNOWN IPv4/APNIC IPv4/ARIN IPv4/RIPE IPv4/LACNIC IPv4/UNKNOWN IPv6/6bone IPv6/IANA IPv6/APNIC IPv6/ARIN IPv6/RIPE IPv6/LACNIC IPv6/RESERVED IPv6/UNKNOWN IPv6/6to4/IANA IPv6/6to4/APNIC IPv6/6to4/ARIN IPv6/6to4/RIPE IPv6/6to4/LACNIC IPv6/6to4/RESERVED IPv6/6to4/UNKNOWN IPv6/Teredo/IANA IPv6/Teredo/APNIC IPv6/Teredo/ARIN IPv6/Teredo/RIPE IPv6/Teredo/LACNIC IPv6/Teredo/RESERVED IPv6/Teredo/UNKNOWN IPv6/NAT64/IANA IPv6/NAT64/APNIC IPv6/NAT64/ARIN IPv6/NAT64/RIPE IPv6/NAT64/LACNIC IPv6/NAT64/RESERVED IPv6/NAT64/UNKNOWN IPv6/IID/Global IPv6/IID/Random IPv6/IID/Manual IPv6/IID/ISATAP IPv6/IID/Unknown
     46233 62292 0 2397 3525 40198 97 16 0 0 129 839 61074 0 0 0 0 0 16 51 0 0 0 0 63 0 90 30 0 0 0 0 0 0 0 0 0 1436 58198 2055 353 0

An optional prefix token can be given (“-p <prefix>”) to create e.g. in a for-loop one line per month and put month in front of statistics, also the header line can be suppressed (“-n”).

    $ zcat ip.bieringer.de-log.201*.gz | ipv6logstats -q -c -n -p ALL
    ALL  46233 62292 0 2397 3525 40198 97 16 0 0 129 839 61074 0 0 0 0 0 16 51 0 0 0 0 63 0 90 30 0 0 0 0 0 0 0 0 0 1436 58198 2055 353 0

### Examples

A demonstration with real data is available at http://mirrors.bieringer.de/stats/timeline.html.

## Apache web server module “mod_ipv6calc”

This Apache web server module (since version 0.99.1, released 2015) interfaces with internal ipv6calc library to support

- Client IP address anonymization “on-the-fly”, exported to IPV6CALC_CLIENT_IP_ANON

  - depending on the configured anonymization method 3rd party database is required

- Country code of client IP address, exported to IPV6CALC_CLIENT_COUNTRYCODE

  - requires 3rd party database: GeoIP or IP2Location or DB-IP.com

- Autonomous System Number (ASN) of client IP address, exported to IPV6CALC_CLIENT_ASN

  - requires 3rd party database: GeoIP

- Registry of client IP address, exported to IPV6CALC_CLIENT_REGISTRY

  - requires internal or “external” database

- Configured IP address anonymization method, exported to IPV6CALC_ANON_METHOD

### Installation

Install compiled Apache module “mod_ipv6calc” to Apache's module directory

Install included default configuration file “ipv6calc.conf” to Apache's config directory (usually conf.d)

### Configuration

Enable in “ipv6calc.conf” loading of module

    LoadModule ipv6calc_module modules/mod_ipv6calc.so

Enable module itself

    ipv6calcEnable                         on

Adjust configuration settings, if needed (see examples in “ipv6calc.conf”)

Review predefined log format

    LogFormat "%{IPV6CALC_CLIENT_IP_ANON}e \"%{IPV6CALC_CLIENT_COUNTRYCODE}e/%{IPV6CALC_CLIENT_ASN}e/%{IPV6CALC_CLIENT_REGISTRY}e/%{IPV6CALC_ANON_METHOD}e\" %u %t \"%r\" %>s %b \"%{Referer}i\" \"%{User-Agent}i\"" combined_anon

Enable custom log with anonymized information, using the predefined LogFormat

    CustomLog logs/access_anon_log combined_anon

Restart Apache web server, check error_log for any issues

### Result

The new log file contains anonymized requests like

    252.176.92.172 "CN/23724/APNIC/keep-type-asn-cc" - [25/Jul/2015:13:20:25 +0200] "GET / HTTP/1.1" 200 3569 "-" "Mozilla/5.0 (compatible; Baiduspider/2.0; +http://www.baidu.com/search/spider.html)"

    a909:390a:909a:81d9:a909:4291:c02d:5d1d "CZ/43037/RIPENCC/keep-type-asn-cc" - [25/Jul/2015:12:59:00 +0200] "GET /robots.txt HTTP/1.1" 200 33 "-" "Mozilla/5.0 (compatible; SeznamBot/3.2; +http://fulltext.sblog.cz/)"

### Post-analysis in case of anonymization method “keep-type-asn-cc”

In case “keep-type-asn-cc” is configured and also working (required databases are available), related information of anonymized IP addresses can be retrieved using “ipv6calc” or “ipv6logstats”.

    $ ipv6calc -q -m -i 252.176.92.172
    IPV4=252.176.92.172
    IPV4_TYPE=unicast,anonymized,global
    IPV4_AS_NUM=23724
    IPV4_COUNTRYCODE=CN
    IPV4_REGISTRY=APNIC
    ...

    $ ipv6calc -q -m -i a909:390a:909a:81d9:a909:4291:c02d:5d1d
    IPV6=a909:390a:909a:81d9:a909:4291:c02d:5d1d
    IPV6_TYPE=unicast,anonymized-iid,anonymized-prefix,global-unicast,productive,iid,iid-local
    IPV6_COUNTRYCODE=CZ
    IPV6_AS_NUM=43037
    IPV6_REGISTRY=RIPENCC
    ...

## History

Major extensions/changes are listed here

### 2017

- add support for LISP detection

- add support for non-free versions DB-IP.com databases

- finally release 1.0.0 after 16 year of development

### 2016

- implement action 'test' and extend action 'filter' with support of address ranges (>= 0.99.2)

### 2015

- Introduce mod_ipv6calc for Apache web server (>= 0.99.1)

- Add support for DB-IP.com databases (by generated Berkeley DB files) (>= 0.98.0)

- Add support for “External” database files (generated Berkeley DB files), superseeding (if newer) built-in IPv4/IPv6->Registry and adding IPv4/IPv6->CountryCode support (>= 0.98.0)

- Extend filter options with support of CountryCode, ASN or Registry (>= 0.99.0)

- Add support for IP2Location LITE databases (>= 0.99.0), add configurable IP2Location database autoselection support

### 2014

- Shared library mode supported (reduces size of binaries)

### 2013

- Prefix and IID anonymization methods

- Support of dynamic load of GeoIP and IP2Location libraries

- Specifying dedicated GeoIP and IP2Location database files is now replaced by specifying dedicated database directories to make especially for GeoIP use of more database files.

### 2011

- ipv6calc/ipv6calcweb.cgi: enable included GeoIP support with IPv6 (usable with GeoIP >= 1.4.5)

- ipv6calc: extend for 6rd support (--action 6rd_local_prefix --6rd_prefix <PREFIX> --6rd_relay_prefix <RELAY_PREFIX>)

- ipv6calc: enable stdin support for bulk transformation

- ipv6calc: add support for NAT64 address type

- ipv6calc: add option “forceprefix <LENGTH>” to print prefix of an address without a given prefix length

- ipv6loganon: extend for pipe usage (e.g. in Apache log file directive) and write/append to specified file

- General: add configure options to disable built-in databases (reduce binary size a lot, e.g. for embedded devices)

### 2002-2010

See ChangeLog@GitHub for now

### 2001

- Start of development